%define name	xemacs
%define ver	21.1.14
%define rel	2

Name: %{name}
Version: %{ver}
Release: %{rel}
Serial: 2001062901
Copyright: GPL
Group: Applications/Editors/Emacs
Source0: %{name}-%{ver}.tar.bz2
Source1: %{name}-%{ver}-elc.tar.gz
Source2: %{name}-%{ver}-info.tar.gz
Source3: %{name}.wmconfig
Source4: Emacs.ad.Japanese
Source5: unexelf.c
patch0: %{name}-wnn.patch
Patch1: %{name}-21.1.9-static.patch
Requires: compface
#NoSource: 0
#NoSource: 1
#NoSource: 2
BuildRequires: Canna-devel, Wnn6-devel compface
URL: http://www.xemacs.org/
BuildRoot: /var/tmp/%{name}-%{ver}-root
Summary: The XEmacs editor
Summary(ja): XEmacs ǥ
Obsoletes: xemacs, xemacs-el, xemacs-extras, xemacs-static  

%description
XEmacs is a version of Emacs, compatible with and contain-
ing many improvements over GNU Emacs, written  by  Richard
Stallman  of  the Free Software Foundation.  It was origi-
nally based on an early release of GNU Emacs  Version  19,
and  has  tracked subsequent releases of GNU Emacs as they
have become available.

This XEmacs distribution has been split into different packages:
- xemacs              : the main part (with Canna, Wnn4 & XIM support)
- xemacs-el           : the elisp sources 
- xemacs-extra        : files that conflict with FSF Emacs

And you may have to also install xemacs-sumo package,
that provides tons of nifty elisps, including mule feature.

%description -l ja
XEmacs  Free Software Foundation  Richard Stallman ˤä
񤫤줿 GNU Emacs ȤθߴݻĤĿ¿βɤܤ줿
СǤ
 Emacs 19 򸵤˳ȯ졤Emacs θ³꡼ɲä줿
ǽƱƤޤ

 XEmacs ѥåϤĤΥ֥ѥåʬƤޤ:
- xemacs              : XEmacs  (Canna, Wnn4, XIM б)
- xemacs-el           : Emacs Lisp ե
- xemacs-extra        : Emacs  Mule ȶ̤ե

ޤƱ xemacs-sumo ѥå⥤󥹥ȡ뤹ɬפǤ礦
mule ǽϤᡤ¿ elisp ϿƤޤ


%package extra
Group: Applications/Editors/Emacs
Summary: files which conflict with Emacs and Mule
Summary(ja): Emacs, Mule ȶ̤ XEmacs ѥե
Requires: %{name} = %{ver}

%description extra
These files are common between FSF Emacs, Mule and XEmacs.
If you do not have FSF Emacs installed, be sure to install
this package as well when you install XEmacs.

%description -l ja extra
Emacs, Mule, XEmacs ֤Ƕ̤ΥեǤ
Emacs  Mule 򥤥󥹥ȡ뤷Ƥʤ
Υѥå⥤󥹥ȡ뤷Ʋ


%package el
Group: Applications/Editors/Emacs
Summary: The source files of the standard elisp modules for XEmacs
Summary(ja): XEmacs  elisp ե
Requires: %{name} = %{ver}

%description el
This package contains the source files of the standard elisp
modules for XEmacs.  The package is not necessary to run XEmacs.

%descripion -l ja el
Υѥåˤ XEmacs  Emacs Lisp ե뤬
ƤޤXEmacs ưΤɬܤǤϤޤ


%prep
%setup -n xemacs-%{ver} -q -b 1 -b 2
%patch0 -p1 -b .wnnpatch
%patch1 -p1 -b .wnn-canna


(cd lisp;
 rm -rf apel auctex bytecomp calendar cc-mode cl comint custom dired edebug
 rm -rf ediff efs egg electric emulators energize eos epoch eterm gnats gnus
 rm -rf hm--html-menus hyperbole ilisp iso its language leim locale mailcrypt
 rm -rf mel mh-e modes mu ns oobr packages pcl-cvs prim psgml quail rmail
 rm -rf skk sunpro tl tm url utils viper vm vms w3 w32 x11)

# replace a default resource file
cp %{SOURCE4} etc/Emacs.ad

# replace a src/unexelf.c with the one from 21.1.4
#cp %{SOURCE5} src/unexelf.c

%build

./configure \
    --cflags="${RPM_OPT_FLAGS} -fno-caller-saves" \
    --prefix=usr --lockdir=/var/lock/xemacs \
    --mandir=/usr/share/man \
    --error-checking=no --debug=no \
    --with-offix=no \
    --with-xface=yes \
    --with-dialogs=athena \
    --with-menubars=lucid \
    --with-xfs \
    --with-pop \
    --with-sound=no \
    --with-mule \
    --with-xim=xlib \
    --with-ldap=no
#     --site-includes=/usr/include/canna:/usr/include/wnn6 \ 
#     --site-libraries=/usr/lib 

make xemacs
strip src/xemacs
make all-elc
make info

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

install -m 0777 -d ${RPM_BUILD_ROOT}/var/lock/xemacs

make prefix=${RPM_BUILD_ROOT}/usr \
	lockdir=${RPM_BUILD_ROOT}/var/lock/xemacs \
	install-arch-dep 
make prefix=${RPM_BUILD_ROOT}/usr \
	lockdir=${RPM_BUILD_ROOT}/var/lock/xemacs \
	mandir=${RPM_BUILD_ROOT}/usr/share/man/man1 \
	install-arch-indep 
make prefix=${RPM_BUILD_ROOT}/usr \
	lockdir=${RPM_BUILD_ROOT}/var/lock/xemacs \
	gzip-el
gunzip $RPM_BUILD_ROOT/usr/lib/%{name}-%{ver}/lisp/package-info.el


mkdir -p ${RPM_BUILD_ROOT}/usr/lib/xemacs/site-packages/etc
mkdir -p ${RPM_BUILD_ROOT}/usr/lib/xemacs/site-packages/info
mkdir -p ${RPM_BUILD_ROOT}/usr/lib/xemacs/site-packages/lib-src
mkdir -p ${RPM_BUILD_ROOT}/usr/lib/xemacs/site-packages/lisp
mkdir -p ${RPM_BUILD_ROOT}/usr/lib/xemacs/site-packages/man
mkdir -p ${RPM_BUILD_ROOT}/usr/lib/xemacs/site-packages/pkginfo

gzip -n -9f ${RPM_BUILD_ROOT}/usr/lib/%{name}-%{ver}/info/*.inf*


DIR="${RPM_BUILD_ROOT}/usr/lib/%{name}-%{ver}"
EL="*.el.gz"

find $DIR -type d |
  sed -e "s#^${RPM_BUILD_ROOT}#%dir #" > rpm-files

find $DIR -name $EL -type f |
  sed -e "s#^${RPM_BUILD_ROOT}##" > rpm-el-files

find $DIR -not -name $EL -type f |
  sed -e "
    s#^${RPM_BUILD_ROOT}\(.*movemail\)#%attr(2755, root, mail) \1#
    s#^${RPM_BUILD_ROOT}##
  " >> rpm-files

mkdir -p -m 755 ${RPM_BUILD_ROOT}/etc/X11/wmconfig
install -m 644 %SOURCE3 ${RPM_BUILD_ROOT}/etc/X11/wmconfig/xemacs
echo "%config /etc/X11/wmconfig/xemacs" >> rpm-files

mkdir -p ${RPM_BUILD_ROOT}/etc/skel
mkdir -p ${RPM_BUILD_ROOT}/root

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files -f rpm-files
%defattr(-,root,root)
%doc BUGS CHANGES-beta COPYING ChangeLog GETTING.GNU.SOFTWARE
%doc INSTALL PROBLEMS README README.packages
%dir /var/lock/xemacs
%dir /usr/lib/xemacs
%dir /usr/lib/xemacs/site-packages
%dir /usr/lib/xemacs/site-packages/etc
%dir /usr/lib/xemacs/site-packages/info
%dir /usr/lib/xemacs/site-packages/lib-src
%dir /usr/lib/xemacs/site-packages/lisp
%dir /usr/lib/xemacs/site-packages/man
%dir /usr/lib/xemacs/site-packages/pkginfo
/usr/bin/gnuattach
/usr/bin/gnuclient
/usr/bin/gnudoit
/usr/bin/ootags
#/usr/bin/pstogif
#/etc/skel/.emacs
#/root/.emacs
/usr/share/man/man1/gnuattach.1*
/usr/share/man/man1/gnudoit.1*
/usr/share/man/man1/gnuserv.1*
/usr/share/man/man1/xemacs.1*

/usr/bin/xemacs
#/usr/bin/xemacs-static
/usr/bin/xemacs-%{ver}


%files extra
%defattr(-,root,root)
/usr/bin/b2m
/usr/bin/ctags
/usr/bin/etags
/usr/bin/rcs-checkin
/usr/share/man/man1/ctags.1*
/usr/share/man/man1/etags.1*


%files -f rpm-el-files el
%defattr(-,root,root)

%changelog
* Fri Jun 29 2001 Akira Nonaka <anonaka@miraclelinux.com>
- Added compface to BuildRequires

* Mon Feb  5 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to version 21.1.14.

* Fri Jan 12 2001 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to version 21.1.13.

* Fri Jul  7 2000 SL Baur  <steve@turbolinux.co.jp>
- move man pages to /usr/share/man
- de-bash
- add RPM-3.0.5 compatibility
- Alpha port
- Remove overspecified configure options
- Remove useless lisp directories in 21.1.10 tarball

* Mon May 08 2000 Masaru Yokoi <masaru@turbolinux.co.jp>
- Updated to 21.1.10.

* Fri Mar 10 2000 Toshihiro Yamagishi<Toshihiro.Yamagishi@turbolinux.co.jp>
  - add static patch to static link libcanna and libwnn

* Thu Mar  2 2000 Toshihiro Yamagishi<Toshihiro.Yamagishi@turbolinux.co.jp>
  - up to 21.1.9

* Thu Jan 20 2000 Toshihiro Yamagishi<Toshihiro.Yamagishi@turbolinux.co.jp>
  - remove DND require and OffiX option to off

* Tue Dec 21 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.8-1
  - updated to 21.1.8 release
  - included a patch for wnn6 when both libwnn6 and FreeWnn* are installed

* Sat Oct  2 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-10
  - fixed a critical mistake in the Japanese description

* Fri Oct  1 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-9
  - added a patch for the problem that xemacs dumps core (hopefully...)

* Thu Sep 23 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-8
  - Requires: tags changed - compface package is replaced with
    faces, faces-xface, faces-devel packages (from Red Hat Rawhide)

* Mon Sep 20 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-7
  - rebuilt with XFree86-3.3.5 for Vine 1.9

* Tue Sep 14 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-6
  - added "-fno-caller-saves" flag in the -cflag
  - added sub-package for static-linked version of binary executable
    (--ldflag=-static)

* Wed Sep  1 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-5
  - changed from HOSTTYPE=i386-pc-linux to HOSTTYPE=i386-vine-linux
  - added "--with-offix=yes" optional flag
  - "Requires: dnd, dnd-devel" added for "--with-offix=yes" option
  - "Requires: xemacs-sumo = %{sumoversion}" added again :-(

* Mon Aug 30 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-4
  - "Requires: xemacs-sumo = %{sumoversion}" removed
  - yet another changes for the ./configure optional flags,
    namely removing "-D_GNU_SOURCE" option

* Sun Aug 29 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-3
  - force Wnn support disabled (with --with-wnn=no)
    for the in-stock Vine configuration
  - slight more modifications for the spec file

* Fri Aug 27 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-2
  - force png support enabled (with --with-png=yes)
  - cleaned up spec file

* Wed Aug 25 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
  - 21.1.6-1
  - 1st RPM release

